extends Resource
class_name MajorityJudgmentAbstractTallier


"""
Interface pattern, kind of.
This will allow us to provide multiple tallying algorithms.

To make you own:
Extend this, override `tally()`, and register it. (undecided about how yet)

Expected algorithms:
	- Easy (expensive but simple to understand)
	- Fast (optimized for speed and scalability)
	- Liquid (handles delegations without loops)
	- Quantic (handles delegations with loops)
	- Empathic (handles non-sentient)
	- Holistic (handles everything) (trololol)
"""


func tally(poll) -> MajorityJudgmentPollTally:
	assert(false, "Override me")
	return null
